<!-- ***************************************************************** -->
<sect>Introduction
<!-- ***************************************************************** -->
<p>
Gtk-- is a C++ wrapper for GTK, a library for creating graphical user
interfaces. It is licensed using the LGPL license, so you can develop
open software, free software, or even commercial non-free software
using Gtk-- without having to spend anything for licenses or royalties.

The primary authors of Gtk-- are:

<itemize>
<item> Tero Pulkinnen   <tt><htmlurl url="mailto:terop@assari.cc.tut.fi"
			   name="terop@assari.cc.tut.fi"></tt>
<item> Karl Nelson <tt><htmlurl url="mailto:"
			   name="kenelson@ece.ucdavis.edu"></tt>
<item> Guillaume Laurent <tt><htmlurl url="mailto:glaurent@worldnet.fr"
			   name="glaurent@worldnet.fr"></tt>
</itemize>

This tutorial is an attempt to document as much as possible of Gtk--,
but it is by no means complete. This tutorial assumes a good
understanding of C++, and how to create C++ programs. Some basic C++
vocabulary and abbreviations are used, like "ctor" and "dtor" for
"constructor" and "destructor", and "method" for "member functions".

It would be a great benefit for the reader to have previous X
programming experience, but it shouldn't be necessary. If you are
learning Gtk-- as your first widget set, please comment on how you
found this tutorial, and what you had trouble with.

This document is a 'work in progress'. Please look for updates on
http://lazy.ton.tut.fi/gtk-- <htmlurl url="http://lazy.ton.tut.fi/gtk--"
name="http://lazy.ton.tut.fi/gtk--">.

I would very much like to hear of any problems you have learning Gtk--
from this document, and would appreciate input as to how it may be
improved. Please see the section on <ref id="sec_Contributing"
name="Contributing"> for further information.

