/*
** ===========================================================================
** $RCSfile: PixmapTest.h,v $
** $Revision: 1.2 $
** $Date: 1999/06/23 22:02:35 $
** $Author: terop $
** ===========================================================================
*/

/*
 * GtkPixmap
 */

#include "TestFixture.h"

#ifndef PixmapTest_h
#define PixmapTest_h "$Id: PixmapTest.h,v 1.2 1999/06/23 22:02:35 terop Exp $"


class PixmapTest : public TestFixture 
{
public:
  static TestFixture *  create ();
  virtual              ~PixmapTest () { };
  virtual void          destroyTest () { delete theTest; theTest = 0; }
private:
                        PixmapTest ();
  // functions
  void                  toggleShowButton ( int buttonIndex );
  // data
  static PixmapTest * theTest;

  Gtk_VBox       vbox1;
  Gtk_VBox       vbox2;
  Gtk_HBox       hbox3;
  Gtk_VBox       vbox4;
  Gtk_Button     button;
  Gtk_Pixmap    *pixmap;
  Gtk_Label      label;
  Gtk_HSeparator separator;
};

#endif
