/*
** ===========================================================================
** $RCSfile: TooltipsTest.h,v $
** $Revision: 1.2 $
** $Date: 1999/06/23 22:02:52 $
** $Author: terop $
** ===========================================================================
*/

/*
** Gtk_Button
*/

#include "TestFixture.h"

#ifndef TooltipsTest_h
#define TooltipsTest_h "$Id: TooltipsTest.h,v 1.2 1999/06/23 22:02:52 terop Exp $"


class TooltipsTest : public TestFixture 
{
public:
  static TestFixture *  create ();
  virtual              ~TooltipsTest () { };
  virtual void          destroyTest () { delete theTest; theTest = 0; }
private:
                        TooltipsTest ();
  // functions
  void                  toggleShowButton ( int buttonIndex );
  // data
  static TooltipsTest * theTest;

  Gtk_Tooltips     tooltips;
  Gtk_VBox         vbox1;
  Gtk_VBox         vbox2;
  Gtk_ToggleButton toggleButton1;
  Gtk_ToggleButton toggleButton2;
  Gtk_ToggleButton toggleButton3;
  Gtk_VBox         vbox3;
  Gtk_TipsQuery    tipsQuery;
  Gtk_Button       button;
  Gtk_Frame        frame;

  void widget_entered ( Gtk_Widget      *widget,
			const gchar     *tip_text,
			const gchar     *tip_private );

  gint widget_selected ( Gtk_Widget      *widget,
			 const gchar    *tip_text,
			 const gchar    *tip_private,
			 GdkEventButton *event );

};

#endif
